from django.conf.urls.defaults import patterns, include, url

import os
from ox.django.http import HttpFileResponse

from django.conf import settings

from django.contrib import admin
admin.autodiscover()

from api import actions
actions.autodiscover()

def serve_static_file(path, location, content_type):
    return HttpFileResponse(location, content_type=content_type)

urlpatterns = patterns('',
    (r'^admin/', include(admin.site.urls)),

    (r'^api/$', include('api.urls')),
    (r'^$', 'app.views.index'),
    (r'', include('item.urls')),
    (r'^robots.txt$', serve_static_file, {'location': os.path.join(settings.STATIC_ROOT, 'robots.txt'), 'content_type': 'text/plain'}),
    (r'^favicon.ico$', serve_static_file, {'location': os.path.join(settings.STATIC_ROOT, 'png/icon.16.png'), 'content_type': 'image/x-icon'}),
)

if settings.DEBUG:
    urlpatterns += patterns('',
        (r'^data/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^static/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.STATIC_ROOT}),
    )
